#include "stdafx.h"
#include "MyConfFile.h"

MyConfFile::MyConfFile()
{
}

MyConfFile::~MyConfFile()
{
}

//-----------------------------------------------------------------------------
//	@detail
//		Add data
//	@param
//		char*	pszKey;
//		char*	pszValue;
//	@return
//		0 indicate an error
//-----------------------------------------------------------------------------
int	MyConfFile::Set( char* pszKey, char* pszValue )
{
	return MyHash::Set( pszKey, pszValue );
}

//-----------------------------------------------------------------------------
//	@detail
//		Load file
//	@param
//		WCHAR*	ptszFile;	file name	(UTF-2)
//	@return
//		0 indicate an error
//-----------------------------------------------------------------------------
int MyConfFile::LoadFile(WCHAR *pwszFile)
{
	// --------------------------------------------------------------
	// Read all the contents of a file.
	HANDLE hFile = CreateFile(pwszFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	MyVarMem	vm;

	if( hFile == INVALID_HANDLE_VALUE )
	{
		return 0;
	}
	else
	{
		char	szBuf[500];
		BOOL	bResult;
		DWORD	dwReadBytes;
		do
		{
			bResult = ReadFile( hFile, szBuf, 500, &dwReadBytes, NULL );
			
			if(dwReadBytes == 0)
				break;

			// ----------------------------------------------------
			// Error no memory.
			if( 0 == vm.Add( szBuf, dwReadBytes ) )
			{
				CloseHandle(hFile);
				return 0;
			}

		}while( bResult );

		CloseHandle(hFile);
	}

	if( vm.GetLength() == 0 )
	{
		return 0;
	}
	// ..File read end

	// --------------------------------------------------------------
	// Parse file by cr/lf.
	char*	pCurrentLine;
	char*	pNextLine;

	pCurrentLine = pNextLine = (char*)vm.GetBuffer();

	do
	{
		while( *pNextLine == '\r' ||  *pNextLine == '\n' )
			pNextLine++;

		if( *pNextLine == '\0' )
			return 0;

		pCurrentLine = pNextLine;

		// seek to next line
		while( *pNextLine != '\r' &&  *pNextLine != '\n' && *pNextLine != '\0' )
		{
			pNextLine++;
		}

		if( *pNextLine != '\0' )
			*pNextLine++ = '\0';
		
		// ignore the comment symbole
		if( *pCurrentLine == '#' )
		{
			continue;
		}
		else
		{
			char* pKey;
			char* pValue;

			pKey = pCurrentLine;
			pValue = pCurrentLine;

			while( *pValue != ' ' && *pValue != '\t' && *pValue != '\0' )
			{
				pValue++;
			}

			// there is no value string;
			if( *pValue == '\0' )
				continue;

			*pValue++ = '\0';

			while( *pValue == ' ' || *pValue == '\t' )
			{
				pValue++;
			}

			Set(pKey, pValue);

		}

		// next line
	}while( *pNextLine != '\0' );
	return 1;
}

//-----------------------------------------------------------------------------
//	@detail
//		Serch the value from contents.
//		This function is for multi-thread safe.
//	@param
//		cahr*	pszKey;		find key
//	@return
//		find strings
//		otherwise null
//-----------------------------------------------------------------------------
char* MyConfFile::GetValueEx(char *pszKey)
{
	char* p = SeekToKeyIEx(pszKey);
	
	if( p == NULL )
	{
		return NULL;
	}
	else
	{
		while(*p++ != '\0');
	}
	
	return p;
}

//-----------------------------------------------------------------------------
//	@detail
//		Seek key. perform a lowercase comparison.
//		This function is for multi-thread safe.
//	@param
//		
//	@return
//		
//-----------------------------------------------------------------------------
char*	MyConfFile::SeekToKeyIEx(char* pszKey)
{
	// set pointer to head of buffer
	char* p = (char*) m_pHeap->GetBuffer();

	if( p == NULL )
	{
		return NULL;
	}

	while(StrCmpI(p, pszKey) != 0)
	{
		p = SeekNextEx(p);

		if( p == NULL )
			return NULL;
	}
	return (m_pszSeekPointer = p);
}

//-----------------------------------------------------------------------------
//	@detail
//		Seek next key
//		This function is for multi-thread safe.
//	@param
//		char*	pszKey;	current key
//	@return
//		
//-----------------------------------------------------------------------------
char*	MyConfFile::SeekNextEx(char* pszKey)
{
	if( pszKey == NULL )
	{
		return NULL;
	}
	char* p = pszKey;
		
	// Seek to head of 'value'
	while(*p++ != '\0');
	
	// 'value' is NULL
	if( p[0] == '\0' && p[1] == '\0' )
	{
		return NULL;
	}

	// Seek to next key.
	while(*p++ != '\0');

	// If terminate, return NULL.
	if( *p == '\0' )
	{
		pszKey = p;
		return NULL;
	}

	return (pszKey = p);
}
